#ifndef	ISTRINGS_H
#define	ISTRINGS_H

#define	IPL_OPEN_BRACE		"{"
#define	IPL_CLOSE_BRACE		"}"
#define	IPL_OPEN_BRACKET	"("
#define	IPL_CLOSE_BRACKET	")"
#define	IPL_COMMA			","
#define	IPL_DOT				"."
#define	IPL_SEMICOLON		";"
#define	IPL_BASENAME		"ipl"
#define	IPL_COMMENT_CHAR	'#'
#define	IPL_DOT_CHAR		','		/* decimal separator */

EXTERN_STRING(ipl_usage)
EXTERN_STRING(ipl_exit_status)
EXTERN_STRING(ipl_integer)
EXTERN_STRING(ipl_key_global)
EXTERN_STRING(ipl_key_random_seed)
EXTERN_STRING(ipl_key_alias)
EXTERN_STRING(ipl_unable_to_open)
EXTERN_STRING(ipl_success)
EXTERN_STRING(ipl_error)

EXTERN_STRING(ipl_open_brace)
EXTERN_STRING(ipl_close_brace)
EXTERN_STRING(ipl_open_bracket)
EXTERN_STRING(ipl_close_bracket)
EXTERN_STRING(ipl_comma)
EXTERN_STRING(ipl_key_void)
EXTERN_STRING(ipl_key_true)
EXTERN_STRING(ipl_key_false)
EXTERN_STRING(ipl_key_source_space)
EXTERN_STRING(ipl_key_rgb)
EXTERN_STRING(ipl_key_hsv)
EXTERN_STRING(ipl_key_cie)
EXTERN_STRING(ipl_key_red)
EXTERN_STRING(ipl_key_green)
EXTERN_STRING(ipl_key_blue)
EXTERN_STRING(ipl_key_alpha)
EXTERN_STRING(ipl_key_hue)
EXTERN_STRING(ipl_key_saturation)
EXTERN_STRING(ipl_key_value)
EXTERN_STRING(ipl_key_cieX)
EXTERN_STRING(ipl_key_cieY)
EXTERN_STRING(ipl_key_cieZ)
EXTERN_STRING(ipl_key_output)
EXTERN_STRING(ipl_key_matrix)
EXTERN_STRING(ipl_key_vector)
EXTERN_STRING(ipl_key_decomposition)
EXTERN_STRING(ipl_key_state)
EXTERN_STRING(ipl_tab_string)
EXTERN_STRING(ipl_eol_string)
/* decomp.c::iplSaveDecompositionDescription */
EXTERN_STRING(ipl_key_source_dimension)
EXTERN_STRING(ipl_key_depth_range)
EXTERN_STRING(ipl_key_area_range)
EXTERN_STRING(ipl_key_value_range)
EXTERN_STRING(ipl_key_at_depth)
EXTERN_STRING(ipl_key_leafs)
EXTERN_STRING(ipl_key_values)
EXTERN_STRING(ipl_key_histogram)
EXTERN_STRING(ipl_key_width_of)
EXTERN_STRING(ipl_desc_width_of)
EXTERN_STRING(ipl_key_height_of)
EXTERN_STRING(ipl_desc_height_of)
EXTERN_STRING(ipl_key_size_of)
EXTERN_STRING(ipl_desc_size_of)
EXTERN_STRING(ipl_key_depth_of)
EXTERN_STRING(ipl_desc_depth_of)

EXTERN_STRING(ipl_known_transforms_str)
EXTERN_STRING(ipl_valid_builtin_vars_str)
EXTERN_STRING(ipl_builtin_consts_str)

/*
 * Keys and descriptions for ipltrans.c. The global string can't be used
 * because of definition of the nsl_var_entry_t.
 */

/* Built-in variables */
 
#define	IPL_MAX_IDX_KEY		"$MAX_IDX"
#define	IPL_MAX_IDX_DESC	"maximal index of element"

#define	IPL_IDX_KEY			"$IDX"
#define	IPL_IDX_DESC		"index of element"

#define	IPL_ELEM_KEY		"$ELEM"
#define	IPL_ELEM_DESC		"value of current element"

#define	IPL_ELEM1_KEY		"$ELEM1"
#define	IPL_ELEM1_DESC		"value of element of current vector"

#define	IPL_ELEM2_KEY		"$ELEM2"
#define	IPL_ELEM2_DESC		"value of element of other vector"

#define	IPL_MAX_ROW_KEY		"$MAX_ROW"
#define	IPL_MAX_ROW_DESC	"maximal index of row"

#define	IPL_MAX_COL_KEY		"$MAX_COL"
#define	IPL_MAX_COL_DESC	"maximal index of column"

#define	IPL_ROW_KEY			"$ROW"
#define	IPL_ROW_DESC		"current row"

#define	IPL_COL_KEY			"$COL"
#define	IPL_COL_DESC		"current column"

#define	IPL_CELL_KEY		"$CELL"
#define	IPL_CELL_DESC 		"value of current cell"

#define	IPL_CELL1_KEY		"$CELL1"
#define	IPL_CELL1_DESC 		"value of element of current matrix"

#define	IPL_CELL2_KEY		"$CELL"
#define	IPL_CELL2_DESC 		"value of element of other matrix"

#define	IPL_NEG_FREQ_KEY	"$NEG_FREQ"
#define	IPL_NEG_FREQ_DESC	"one means negative frequency"

#define	IPL_RE_KEY			"$RE"
#define	IPL_RE_DESC			"real part of current FT cell"

#define	IPL_IM_KEY			"$IM"
#define	IPL_IM_DESC			"imaginary part of current FT cell"

#define	IPL_RE1_KEY			"$RE1"
#define	IPL_RE1_DESC		"real part of cell of current FT"

#define	IPL_IM1_KEY			"$IM1"
#define	IPL_IM1_DESC		"imaginary part of cell of current FT"

#define	IPL_RE2_KEY			"$RE2"
#define	IPL_RE2_DESC		"real part of cell of other FT"

#define	IPL_IM2_KEY			"$IM2"
#define	IPL_IM2_DESC		"imaginary part of cell of other FT"

#define	IPL_MAG_KEY			"$MAG"
#define	IPL_MAG_DESC		"magnitude of current FT cell"

#define	IPL_PHASE_KEY		"$PHASE"
#define	IPL_PHASE_DESC		"phase of current FT cell"

#define	IPL_MAG1_KEY		"$MAG1"
#define	IPL_MAG1_DESC		"magnitude of cell of current FT"

#define	IPL_PHASE1_KEY		"$PHASE1"
#define	IPL_PHASE1_DESC		"phase of cell of current FT"

#define	IPL_MAG2_KEY		"$MAG2"
#define	IPL_MAG2_DESC		"magnitude of cell of other FT"

#define	IPL_PHASE2_KEY		"$PHASE2"
#define	IPL_PHASE2_DESC		"phase of cell of other FT"

/* constants */

#define	IPL_PI_KEY			"Pi"
#define	IPL_PI_DESC			"Pi = 3.14159265358979312..."

#define	IPL_E_KEY			"E"
#define	IPL_E_DESC			"e = 2.71828182845904509..."

#define	IPL_MAXREAL_KEY		"MAXREAL"
#define	IPL_MAXREAL_DESC	"maximal value of 'real' variable"

EXTERN_STRING(ipl_key_step)
EXTERN_STRING(ipl_key_pass)

#define	IPL_VECTOR_TRANSFORM_KEY	"vector_transform"
#define	IPL_VECTOR_TRANSFORM_DESC \
	"iterates through elements of vector"

#define	IPL_VECTOR_PAIR_TRANSFORM_KEY	"vector_pair_transform"
#define	IPL_VECTOR_PAIR_TRANSFORM_DESC \
	"iterates through elements of two vectors"

#define	IPL_MATRIX_TRANSFORM_KEY	"matrix_transform"
#define	IPL_MATRIX_TRANSFORM_DESC \
	"iterates through elements of matrix"

#define	IPL_MATRIX_PAIR_TRANSFORM_KEY	"matrix_pair_transform"
#define	IPL_MATRIX_PAIR_TRANSFORM_DESC \
	"iterates through elements of two matrices"

#define	IPL_CARTESIAN_TRANSFORM_KEY	"cartesian_transform"
#define	IPL_CARTESIAN_TRANSFORM_DESC \
	"iterates through (Re,Im) elements of Fourier transform"

#define	IPL_CARTESIAN_PAIR_TRANSFORM_KEY	"cartesian_pair_transform"
#define	IPL_CARTESIAN_PAIR_TRANSFORM_DESC \
	"iterates through (Re,Im) elements of two Fourier transforms"

#define	IPL_POLAR_TRANSFORM_KEY		"polar_transform"
#define	IPL_POLAR_TRANSFORM_DESC \
	"iterates through (Mag,Phase) elements of Fourier transform"

#define	IPL_POLAR_PAIR_TRANSFORM_KEY	"polar_pair_transform"
#define	IPL_POLAR_PAIR_TRANSFORM_DESC \
	"iterates through (Mag,Phase) elements of two Fourier transforms"

#endif	/* !ISTRINGS_H */